<template>
  <v-container fluid>
    <v-col cols="12" md="12" class="py-0">
      <v-row>
        <v-col>
          <h2 class="pad primary--text">
            <v-icon class="iconTitle primary--text" x-large>mdi-folder-account</v-icon>Drive
          </h2>
        </v-col>
      </v-row>
      <v-row>
        <v-icon class="iconNav">mdi-folder-open</v-icon>
        <span class="iconNavTitle caption font-weight-medium">Diretório Atual:</span>

        <v-chip
          label
          small
          :color="driveNav.length === 0 ? 'test' : ''"
          @click="navPath()"
          @mouseover="hover = true"
          @mouseleave="hover = false"
        >
          home
        </v-chip>
        <v-chip
          v-for="(path, index) in driveNav"
          :key="index"
          text
          label
          small
          :color="driveNav.length - 1 === index ? 'test' : ''"
          @click="navPath(path, index)"
        >
          {{ path.name }}
        </v-chip>
        <v-spacer />
        <div class="navDriveOption">
          <v-btn class="button" color="primary" @click="openNewDirectoryDialog" outlined small>
            Criar Diretório
            <v-icon class="pl-1" small>mdi-folder-plus</v-icon>
          </v-btn>
          <v-btn class="mx-2" color="primary" @click="openUploadDialog" outlined small>
            Adicionar Arquivo
            <v-icon class="pl-1" small>mdi-file-upload</v-icon>
          </v-btn>
          <v-btn color="primary" @click="externalLinkDialog = true" outlined small>
            Adicionar Link Externo
            <v-icon class="pl-1" small>mdi-link-variant</v-icon>
          </v-btn>
        </div>
      </v-row>
    </v-col>
    <v-divider class="mt-2" />
    <!-- FOLDERS-->
    <card-directory
      :currently-data-folder="currentlyDataFolder"
      :drive-loading="driveLoading"
      @folder="toChildren"
      @itemToRename="openRenameDialog"
      @itemToDelete="openDeleteDialog"
    />
    <!-- FILES-->
    <card-files
      :currently-data-files="currentlyDataFiles"
      :drive-loading="driveLoading"
      @itemToRename="openRenameDialog"
      @itemToDelete="openDeleteDialog"
      @download="fileDownload"
    />
    <!-- LINKS-->
    <CardLinks
      :currently-data-folder="currentlyDataLinks"
      :drive-loading="driveLoading"
      @folder="toChildren"
      @itemToRename="openRenameDialog"
      @itemToDelete="openDeleteDialog"
    />

    <!-- DIALOGS -->
    <create-directory-dialog
      :new-directory-dialog="newDirectoryDialog"
      :folders="currentlyDataFolder"
      @closeDirectoryDialog="closeDirectoryDialog"
      @newDirectory="newDirectory"
    />
    <rename-dialog
      :rename-dialog="renameDialog"
      :item-to-rename="itemToRename"
      :folders="currentlyDataFolder"
      :files="currentlyDataFiles"
      @closeRenameDialog="closeRenameDialog"
      @renameItem="renameConfirmation"
    />
    <upload-dialog
      :upload-dialog="uploadDialog"
      @closeUploadDialog="closeUploadDialog"
      @uploadItem="uploadConfirmation"
    />
    <!-- Link externo -->
    <create-link-dialog
      :openDialog="externalLinkDialog"
      @closeLinkDialog="externalLinkDialog = false"
      @newExternalLink="newExternalLink"
    />
    <!-- Confirma deletar entidade -->
    <AlertConfirm
      :alert="alert"
      @clickCancelAlert="alert.status = false"
      @clickConfirmAlert="confirmDelete"
    />
  </v-container>
</template>

<script>
import Drive from '../services/drive'
import CardDirectory from '@/components/drive/CardDirectory.vue'
import CardLinks from '@/components/drive/CardExternalLink.vue'
import CardFiles from '@/components/drive/CardFile.vue'
import CreateDirectoryDialog from '@/components/drive/CreateDirectoryDialog.vue'
import CreateLinkDialog from '@/components/drive/CreateExternalLink.vue'
import RenameDialog from '@/components/drive/RenameItemDialog.vue'
import UploadDialog from '@/components/drive/UploadDialog.vue'

export default {
  components: {
    CardDirectory,
    CardFiles,
    CardLinks,
    CreateDirectoryDialog,
    RenameDialog,
    UploadDialog,
    CreateLinkDialog,
  },
  data: () => ({
    hover: false,
    currentlyDataFolder: [],
    currentlyDataFiles: [],
    currentlyDataLinks: [],
    driveNav: [],
    driveLoading: false,
    newDirectoryDialog: false,
    externalLinkDialog: false,
    uploadDialog: false,
    alert: {
      status: false,
      message: '',
      messageOk: 'Sim',
      messageCancel: 'Não',
    },
    itemToDelete: {},
    renameDialog: false,
    itemToRename: {},
    parentOfActualFolder: '',
  }),

  created() {
    this.init()
  },
  methods: {
    init() {
      this.getFolderContent()
    },
    async toChildren(item) {
      this.parentOfActualFolder = item.id
      await this.getFolderContent(item.id)
      this.driveNav.push({ id: item.id, name: item.name })
    },

    async navPath(pathData, index) {
      try {
        if (!pathData) {
          await this.getFolderContent()
          this.driveNav = []
          this.parentOfActualFolder = ''
        } else {
          await this.getFolderContent(pathData.id)
          this.parentOfActualFolder = pathData.id
          this.driveNav = this.driveNav.slice(0, index + 1)
        }
      } catch (e) {
        console.log('TCL: navPath -> e', e)
      }
    },

    async getFolderContent(parentId) {
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        const ret = await Drive.readFoldercontent(parentId)
        console.log('getFolderContent -> ret ', ret)

        this.currentlyDataFolder = []
        this.currentlyDataFiles = []
        this.currentlyDataLinks = []
        if (ret.data) {
          if (ret.data.folders) {
            ret.data.folders.forEach((folder) => {
              if (folder.name.indexOf('Material de apoio') != -1) folder.name = 'Material de Apoio'
              if (folder.name.indexOf('Trabalho colaborativo') != -1)
                folder.name = 'Trabalho Colaborativo'
            })
            this.currentlyDataFolder = ret.data.folders
          }
          if (ret.data.files) this.currentlyDataFiles = ret.data.files
          if (ret.data.externalLinks) this.currentlyDataLinks = ret.data.externalLinks
        }
      } catch (e) {
        console.error('TCL: init -> e', e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    async createFolder(name) {
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret
        if (!this.driveNav.length) {
          ret = await Drive.createFolder(name)

          this.getFolderContent()
        } else {
          console.log(this.driveNav);
          const parentId = this.driveNav[this.driveNav.length - 1].id
          ret = await Drive.createFolder(name, parentId)
          this.getFolderContent(parentId)
        }
        if (ret.success) {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Diretório <b>criado</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
        } else {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Erro! Não foi possível <b>criar</b> o diretório.',
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
        console.log('TCL: createFolder -> ret', ret)
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    async createExternalLink(data) {
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        console.log('driveNav', this.driveNav)
        let ret
        if (!this.driveNav.length) {
          ret = await Drive.createExternalLink(data.name, data.link)

          this.getFolderContent()
        } else {
          const parentId = this.driveNav[this.driveNav.length - 1].id
          ret = await Drive.createExternalLink(data.name, data.link, parentId)
          this.getFolderContent(parentId)
        }
        if (ret.success) {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Link Externo <b>criado</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
        } else {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Erro! Não foi possível <b>criar</b> o link externo.',
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
        console.log('TCL: createExternalLink -> ret', ret)
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    async renameFolder(newName, folderId) {
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        const ret = await Drive.renameFolder(newName, folderId)
        if (!this.driveNav.length) {
          this.getFolderContent()
        } else {
          const parentId = this.driveNav[this.driveNav.length - 1].id
          this.getFolderContent(parentId)
        }
        if (ret.success) {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Diretório <b>renomeado</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
        } else {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Erro! Não foi possível <b>renomear</b> o diretório.',
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
      } catch (e) {
        console.error('TCL: init -> e', e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    async renameFile(newName, fileId) {
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        const ret = await Drive.renameFile(newName, fileId)
        if (!ret.success) return console.error('Erro: renameFile', ret.data)
        if (!this.driveNav.length) {
          this.getFolderContent()
        } else {
          const parentId = this.driveNav[this.driveNav.length - 1].id
          this.getFolderContent(parentId)
        }
        if (ret.success) {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Arquivo <b>renomeado</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
        } else {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Erro! Não foi possível <b>renomear</b> o arquivo.',
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
      } catch (e) {
        console.error('TCL: init -> e', e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    async renameExternalLink(linkId, update) {
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        const ret = await Drive.renameExternalLink(linkId, update)
        if (!ret.success) return console.error('Erro: renameLink', ret.data)
        if (!this.driveNav.length) {
          this.getFolderContent()
        } else {
          const parentId = this.driveNav[this.driveNav.length - 1].id
          this.getFolderContent(parentId)
        }
        if (ret.success) {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Link externo <b>renomeado</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
        } else {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Erro! Não foi possível <b>renomear</b> o link externo.',
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
      } catch (e) {
        console.error('TCL: init -> e', e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    async fileDownload(item) {
      const fileId = item.id
      const fileName = item.name
      const fileExtension = item.extension
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        await Drive.downloadFile(fileId, fileName, fileExtension)
      } catch (e) {
        console.error('TCL: init -> e', e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    openNewDirectoryDialog() {
      this.newDirectoryDialog = true
    },
    closeDirectoryDialog() {
      this.newDirectoryDialog = false
    },
    newDirectory(nameNewDirectory) {
      this.createFolder(nameNewDirectory)
      this.newDirectoryDialog = false
    },
    newExternalLink(linkData) {
      console.log(linkData, 'dado recebido do dialog')
      this.createExternalLink(linkData)
      this.externalLinkDialog = false
    },
    openUploadDialog() {
      this.uploadDialog = true
    },
    closeUploadDialog() {
      this.uploadDialog = false
    },

    async uploadConfirmation(fileData) {
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        const formData = new FormData()
        formData.append('driveFile', fileData.file)
        const parentId = this.driveNav.length ? this.driveNav[this.driveNav.length - 1].id : null,
          ret = await Drive.uploadFile(fileData.fileName, formData, parentId)
        if (!parentId) {
          this.getFolderContent()
        } else {
          this.getFolderContent(parentId)
        }

        if (ret.success) {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Arquivo <b>adicionado</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
        } else {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Erro! Não foi possível <b>adicionar</b> o arquivo.',
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
      } catch (error) {
        console.error('TCL: uploadConfirmation -> error', error)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
      this.closeUploadDialog()
    },

    openDeleteDialog(item) {
      this.alert.status = true
      if (item.extension) {
        this.alert.message = `Você deseja <b>deletar</b> o arquivo <b>${item.name}${item.extension}</b> ?`
      }
      if (!item.extension && !item.link) {
        this.alert.message = `Você deseja <b>deletar</b> o diretório <b>${item.name}</b> ?`
      }
      if (item.link) {
        this.alert.message = `Você deseja <b>deletar</b> o link externo <b>${item.name}</b> ?<br/>${item.link}`
      }
      this.itemToDelete = item
    },

    confirmDelete() {
      let item = this.itemToDelete
      console.log(item)
      if (item.extension) {
        this.deleteFile(item.id)
      }
      if (!item.extension && !item.link) {
        this.deleteFolder(item.id)
      }
      if (item.link) {
        this.deleteLink(item.id)
      }
      this.alert.status = false
    },
    async deleteFile(fileId, parentId) {
      if (this.parentOfActualFolder) parentId = this.parentOfActualFolder
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await Drive.deleteFile(fileId, parentId)

        if (!ret.success) {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Erro! Não foi possível <b>deletar</b> o arquivo.',
            icon: 'mdi-close-circle',
            color: 'red',
          })
        } else {
          this.getFolderContent(this.parentOfActualFolder)
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Arquivo <b>deletado</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
        }
      } catch (e) {
        console.error('TCL: init -> e', e)
      }
    },
    async deleteFolder(folderId, parentId) {
      if (this.parentOfActualFolder) parentId = this.parentOfActualFolder
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await Drive.deleteFolder(folderId, parentId)
        if (!ret.success) {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Erro! Não foi possível <b>deletar</b> o diretório.',
            icon: 'mdi-close-circle',
            color: 'red',
          })
        } else {
          this.getFolderContent(this.parentOfActualFolder)
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Diretório <b>deletado</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
        }
      } catch (e) {
        console.error('TCL: init -> e', e)
      }
    },
    async deleteLink(linkId, parentId) {
      if (this.parentOfActualFolder) parentId = this.parentOfActualFolder
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await Drive.deleteLink(linkId, parentId)
        if (!ret.success) {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Erro! Não foi possível <b>deletar</b> o link externo.',
            icon: 'mdi-close-circle',
            color: 'red',
          })
        } else {
          this.getFolderContent(this.parentOfActualFolder)
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Link externo <b>deletado</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
        }
      } catch (e) {
        console.error('TCL: init -> e', e)
      }
    },

    openRenameDialog(item) {
      this.itemToRename = item
      this.renameDialog = true
    },
    closeRenameDialog() {
      this.renameDialog = false
    },
    renameConfirmation(item) {
      if (this.itemToRename.extension) {
        this.renameFile(item.name, this.itemToRename.id)
      }
      if (!this.itemToRename.extension && !this.itemToRename.link) {
        this.renameFolder(item.name, this.itemToRename.id)
      }
      if (this.itemToRename.link) {
        let update = { name: item.name, link: item.link }
        this.renameExternalLink(this.itemToRename.id, update)
      }
      this.closeRenameDialog()
    },
  },
}
</script>

<style>
.pad {
  padding-left: 25px;
}
.pathSpace {
  padding-left: 10px;
}

.iconTitle {
  padding-right: 15px;
  padding-bottom: 20px;
}
.iconNav {
  padding-left: 10px;
  padding-right: 10px;
  padding-bottom: 10px;
}
.iconNavTitle {
  padding-top: 3px;
  padding-right: 10px;
}
.typeStyle {
  padding-left: 15px;
}

.iconCard {
  transform: scale(1.3);
}
.iconOptionsCard {
  padding-left: 3px;
  padding-right: 3px;
}
.navDriveOption > .v-btn:hover {
  background: #e8e8e8 !important;
  color: #2a0845 !important;
  border: thin solid #e8e8e8 !important;
}
</style>
